/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;
import com.google.common.primitives.UnsignedLong;

/**
 * A job.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Job extends GenericJson {

  /**
   * Job id.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private UnsignedLong id;

  /**
   * List of job changes since it was created. The first change corresponds to the state of the job
   * when it was created.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<JobChange> jobChange;

  static {
    // hack to force ProGuard to consider JobChange used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(JobChange.class);
  }

  /**
   * Identifies this object as a job.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Current job state.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private JobState state;

  /**
   * Job id.
   * The value returned may be {@code null}.
   */
  public UnsignedLong getId() {
    return id;
  }

  /**
   * Job id.
   * The value set may be {@code null}.
   */
  public Job setId(UnsignedLong id) {
    this.id = id;
    return this;
  }

  /**
   * List of job changes since it was created. The first change corresponds to the state of the job
   * when it was created.
   * The value returned may be {@code null}.
   */
  public java.util.List<JobChange> getJobChange() {
    return jobChange;
  }

  /**
   * List of job changes since it was created. The first change corresponds to the state of the job
   * when it was created.
   * The value set may be {@code null}.
   */
  public Job setJobChange(java.util.List<JobChange> jobChange) {
    this.jobChange = jobChange;
    return this;
  }

  /**
   * Identifies this object as a job.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a job.
   * The value set may be {@code null}.
   */
  public Job setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Current job state.
   * The value returned may be {@code null}.
   */
  public JobState getState() {
    return state;
  }

  /**
   * Current job state.
   * The value set may be {@code null}.
   */
  public Job setState(JobState state) {
    this.state = state;
    return this;
  }

}
