/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.coordinate.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;
import com.google.common.primitives.UnsignedLong;

/**
 * Job schedule.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Maps Coordinate API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Schedule extends GenericJson {

  /**
   * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
   * this is true.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean allDay;

  /**
   * Scheduled end time in milliseconds since epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private UnsignedLong endTime;

  /**
   * Identifies this object as a job schedule.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Scheduled start time in milliseconds since epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private UnsignedLong startTime;

  /**
   * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
   * this is true.
   * The value returned may be {@code null}.
   */
  public Boolean getAllDay() {
    return allDay;
  }

  /**
   * Whether the job is scheduled for the whole day. Time of day in start/end times is ignored if
   * this is true.
   * The value set may be {@code null}.
   */
  public Schedule setAllDay(Boolean allDay) {
    this.allDay = allDay;
    return this;
  }

  /**
   * Scheduled end time in milliseconds since epoch.
   * The value returned may be {@code null}.
   */
  public UnsignedLong getEndTime() {
    return endTime;
  }

  /**
   * Scheduled end time in milliseconds since epoch.
   * The value set may be {@code null}.
   */
  public Schedule setEndTime(UnsignedLong endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * Identifies this object as a job schedule.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Identifies this object as a job schedule.
   * The value set may be {@code null}.
   */
  public Schedule setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Scheduled start time in milliseconds since epoch.
   * The value returned may be {@code null}.
   */
  public UnsignedLong getStartTime() {
    return startTime;
  }

  /**
   * Scheduled start time in milliseconds since epoch.
   * The value set may be {@code null}.
   */
  public Schedule setStartTime(UnsignedLong startTime) {
    this.startTime = startTime;
    return this;
  }

}
